; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Main.pb
; Version du fichier : 0.9.1
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 03-06-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Notes de programmation
;
; DONE : Maths
; DONE : Update
; DONE : Static Array
; DONE : Reset
; DONE : Initialize
; DONE : Preference Files
; DONE : Binary Files
; DONE : Encoded Files (Without password)
; DONE : Crypted Files (With password)
; TODO : XML Files (Faire des prototypes  la main avant d'aller plus loin)
; DONE : JSON Files
; DONE : Voir pour faire la gestion des instances avec une Map (Un nom unique par instance) {OK sauf PREFS}
; DONE : Voir pour faire la gestion des instances avec une liste (Utiliser l'index de liste au lieu d'un ID)
; DONE : Ajout des numrations pour les Extra de type "; Enum :"
; DONE : Correction pour les constantes de dimensionnement des tableaux statique, bug total
; DONE : Ajouter les commandes afin de manipuler les listes chaines et tableaux dynamiques (Fouille et triage).
;
; DONE : Methodes Get/Set, Instance Multiple, revue complte  faire.
; DONE : Lecture criture sur fichier Instance Multiple, revue complte  faire.
; DONE : Ajouter la gnration des commandes "Spciales" (Increment, Decrement, Toggle, Looping, Scrolling)
;        Il manque les instances hors module, pas certain que ce soit utile d'ajouter ce support bien que ce n'est pas 
;        difficile  implmenter.
;
; ON-GOING : Voir pour simplifier le code qui gnre le code.
;    -> DONE InstructionBinaryFile() gre les fichiers binaire, Encod et Crypt.
;
; DONE : Voir pour ajouter une commande "Debugging()"
; DONE : Voir ajouter le support des Bases de donnes
; DONE : Ajouter les commandes de recherche par champs pour les listes structures et la recherche pour les listes simples
; DONE : Ajouter les commandes de recherche par champs pour les tableaux structurs et la recherche pour les tableaux simples
; DONE : Ajouter les commandes de recherche par champs et autres Helpers pour les instances multiples.
; DONE : Ajouter la gnration d'une librairie d'encodage matriciel avec Matrice 3X3, 4X4 et 5X5
;        -> Optimisation de la recherche de matrices 5X5 (Threads multiple en f(x) du nombre de CPUs)
; DONE : S'arranger pour ne pas ajouter les commandes SearchInstancesBy... lorsque le type de champs est soit une structure ou un module
; DONE : Les commandes Reset() et Debugging() ont un linefeed en trop lors du passage Primary --> Secondary
; DONE : Les commandes Get et Set dans le cas d'une structure inconnue bogue svre.
;
; DONE : Ajouter un message d'erreur dans le cas ou le nom du Module est manquant.
; DONE : Ajouter un message d'erreur dans le cas ou il n'y a pas de Masque pour la date.
;
; DONE : Dans le cas d'instances par ID, les commandes Get et Set doivent travailler sur l'instance en cour sans avoir un SearchInstance
;        en interne. De la manire dont le code est programm, les commandes First, Last, Previous et Next sont inutiles.
;
; DONE : Dans le cas d'instances par Index, les commandes Get et Set doivent travailler sur l'instance en cour sans avoir un SelectElement
;        en interne. De la manire dont le code est programm, les commandes First, Last, Previous et Next sont inutiles.
;
; DONE : Dans le cas d'instances par Nom, les commandes Get et Set doivent travailler sur l'instance en cour sans avoir un FindMapElement
;        en interne. De la manire dont le code est programm, la commande Next est inutile.
;
; DONE : Il y a un problme lorsque le champs est une list structur, Il ne faut pas gnrer de mthodes Get/Set dans ce cas de figure.
; DONE : Refaire un Scan pour les structures internes, si une structure est supprim entre la 1re et la 2e gnration de code. Le click sur le 
;        bouton Scan enlve la structure de l'interface mais elle reste en mmoire dans Field - Module --> Gnral. Ce bogue fait galement planter
;        le programme si on sauve le projet.
;
; ON-GOING : Bogue svre gnralis dans le cas de structure interne contenant des Modules de type OffModule (Vector3 par exemple). Non 
;            pris en compte pour Initialize() et Reset() entre autre. Voir pour les autres commandes
;            --> Binary file : Faire des tests plus pouss pour chacun des cas de figure.
;
; ABANDON : Voir ajouter le pilotage des Modules prdfinis
; ABANDON : Vour pour gnrer un fichier html d'aide  propos du module gnr
; 
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

IncludeFile "TOOLBOX/ButtonImageGroup - Module.pb"
IncludeFile "TOOLBOX/Sticky - Module.pb"
IncludeFile "TOOLBOX/FormatColor - Module.pb"
IncludeFile "TOOLBOX/Language System - Module.pb"
IncludeFile "TOOLBOX/Window - Module.pb"
IncludeFile "TOOLBOX/Gadget Locate - Module.pb"
IncludeFile "TOOLBOX/OptionGroup - Module.pb"
IncludeFile "TOOLBOX/ButtonGroup - Module.pb"
IncludeFile "TOOLBOX/PastedCodeCleanUp - Module.pb"
IncludeFile "TOOLBOX/Levenshtein - Module.pb"
IncludeFile "TOOLBOX/StringBetween - Module.pb"
IncludeFile "TOOLBOX/DependentGadgets - Module.pb"
IncludeFile "TOOLBOX/BuiltPathDirectory - Module.pb"
IncludeFile "TOOLBOX/CheckFileExtension - Module.pb"
IncludeFile "TOOLBOX/Chrono - Module.pb"
IncludeFile "TOOLBOX/AskPureBasicCompiler - Module.pb"
IncludeFile "TOOLBOX/AdvancedDateFormatting - Module.pb"
IncludeFile "TOOLBOX/Max - Module.pb"
IncludeFile "TOOLBOX/FormatDouble - Module.pb"
IncludeFile "TOOLBOX/FormatMilliSeconds - Module.pb"
IncludeFile "TOOLBOX/ColorPreview Gadget - Module.pb"
IncludeFile "TOOLBOX/RgbToHtml - Module.pb"
IncludeFile "TOOLBOX/ProgressBarEx - Module.pb"
IncludeFile "TOOLBOX/Vector3 Double - Module.pb"
IncludeFile "TOOLBOX/Vector4 Double - Module.pb"
IncludeFile "TOOLBOX/Vector5 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix33 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix44 Double - Module.pb"
IncludeFile "TOOLBOX/Matrix55 Double - Module.pb"

CompilerIf #PB_Compiler_OS = #PB_OS_Linux
  ImportC "-no-pie" : EndImport ; Fix Compiled Program flagged as Shared library
CompilerEndIf

IncludeFile "DevModule - Help.pb"
IncludeFile "DevModule - Stats.pb"
IncludeFile "DevModule - Options.pb"
IncludeFile "DevModule - Comments.pb"
IncludeFile "DevModule - Field.pb"
IncludeFile "DevModule - MatrixEncodedGenerator.pb"
IncludeFile "DevModule - CodeGenerator.pb"
IncludeFile "DevModule - MatrixGenerator.pb"
IncludeFile "DevModule - DevModule.pb"

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Routine d'initialisation du programme <<<<<

DevModule::Initialize() 

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Ouverture de la fentre principale <<<<<

DevModule::CreateWindow()

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Gestion des vnements <<<<<

DevModule::EventManager()

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -
; EnableThread
; EnableXP
; Executable = ../../../Programmes/DevModule/DevModule
; DisableDebugger
; CompileSourceDirectory
; EnableUnicode